﻿Public Class PriorityQueue(Of T)
    ' The items and priorities.
    Public Values As New List(Of T)()
    Public Priorities As New List(Of Integer)()

    ' Return the number of items in the queue.
    Public ReadOnly Property NumItems() As Integer
        Get
            Return Values.Count
        End Get
    End Property

    ' Add an item to the queue.
    Public Sub Enqueue(ByVal new_value As T, ByVal new_priority As Integer)
        Values.Add(new_value)
        Priorities.Add(new_priority)
    End Sub

    ' Remove the item with the largest priority from the queue.
    Public Sub Dequeue(ByRef top_value As T, ByRef top_priority As Integer)
        ' Find the hightest priority.
        Dim best_index As Integer = 0
        top_priority = Priorities(0)
        For i As Integer = 1 To Priorities.Count - 1
            If (top_priority < Priorities(i)) Then
                top_priority = Priorities(i)
                best_index = i
            End If
        Next i

        ' Return the corresponding item.
        top_value = Values(best_index)

        ' Remove the item from the lists.
        Values.RemoveAt(best_index)
        Priorities.RemoveAt(best_index)
    End Sub
End Class
